local AddonName, VoiceCoolDown = ...
local oVoiceCoolDown = LibStub("AceAddon-3.0"):NewAddon(VoiceCoolDown, AddonName, "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("VoiceCoolDown") --Objeto para la gestión de la localización
local ACD = LibStub("AceConfigDialog-3.0")
local ACR = LibStub("AceConfigRegistry-3.0") or error("Required library AceConfigRegistry-3.0 not found")

--Enumeración de las clases y su color de clase
local CLASES_ENUM = {
	{"DEATHKNIGHT",  "|cffC41F3B"},
  {"DRUID",        "|cffFF7D0A"},
	{"HUNTER",       "|cffABD473"},
	{"MAGE",         "|cff00FF96"},
	{"MONK",         "|cff00FF96"},
	{"PALADIN",      "|cffF58CBA"},
	{"PRIEST",       "|cffFFFFFF"},
	{"ROGUE",        "|cffFFF569"},
	{"SHAMAN",       "|cff0070DE"},
	{"WARLOCK",      "|cff9482C9"},
	{"WARRIOR",      "|cffC79C6E"},
}
--Hechizos que puede tracear. Clase - Id - si es alianza u Horda
local HECHIZOS_PORDEFECTO = {
	{"ANY",			59752,	nil},					-- Every Man for Himself
	{"ANY",			20594,	nil},					-- Stoneform: this is the spell in the spellbook
	--{"ANY",			65116,	nil},				-- Stoneform: this is the buff spell effect
	
	{"DRUID",		22812,	nil},					-- Barkskin
	{"DRUID",		22842,	nil},					-- Frenzied Regeneration
	{"DRUID",		29166,	nil},					-- Innervate
	{"DRUID",		20484,	nil},					-- Rebirth
	{"DRUID",		61336,	nil},					-- Survival Instincts
	{"DRUID",		740,	nil},					-- Tranquility
	{"DRUID",		33891,	nil},					-- Tree of Life
	{"DRUID",		5211,	nil},					-- Mighty Bash
	{"DRUID",		102351,	nil},					-- Cenarion Ward (Talent - 5.0)
	{"DRUID",		102342,	nil},					-- Ironbark (5.0)
	{"DRUID",		124974,	nil},					-- Nature's Vigil
  {"DRUID",		102280,	nil},					-- Bestia Tremula
  {"DRUID",		5215,	nil},					  -- Acechar
  {"DRUID",		108294,	nil},					-- Resguardo de la naturaleza
	
	{"HUNTER",		34477,	nil},					--Misdirection
  {"HUNTER",		19263,	nil},					--Disuasion
	
	{"MAGE",		45438,	nil},					-- Ice Block
	{"MAGE",		31687,	nil},					-- Summon Water Elemental
	{"MAGE",		80353,	nil},					-- Time Warp
	{"MAGE",		2139,	nil},					-- Counterspell
	
	{"MONK",		115176,	nil},					-- Zen Meditation
	{"MONK",		116849,	nil},					-- Life Cocoon
	{"MONK",		115310,	nil},					-- Revival
  {"MONK",		123904,	nil},					-- Tigre
	                                                   
	{"PALADIN",		31850,	nil},					-- Ardent Defender
	{"PALADIN",		31821,	nil},					-- Devotion Aura
	{"PALADIN",		498,	nil},					-- Divine Protection
	{"PALADIN",		642,	nil},					-- Divine Shield
	{"PALADIN",		1044,	nil},					-- Hand of Freedom
	{"PALADIN",		1022,	nil},					-- Hand of Protection
	{"PALADIN",		6940,	nil},					-- Hand of Sacrifice
	{"PALADIN",		1038,	nil},					-- Hand of Salvation
	{"PALADIN",		114039,	nil},					-- Hand of Purity
	{"PALADIN",		633,	nil},					-- Lay on Hands
	{"PALADIN",		20066,	nil},					-- Repentance
	{"PALADIN",		86659,	nil},					-- Guardian of Ancient Kings
	{"PALADIN",		96231,	nil},					-- Rebuke
	{"PALADIN",		853,	nil},					-- Hammer of Justice
	{"PALADIN",		105593,	nil},					-- Fist of Justice (5.0.4)
	                                                   
	{"PRIEST",		64843,	nil},					-- Divine Hymn
	{"PRIEST",		47788,	nil},					-- Guardian Spirit
	{"PRIEST",		64901,	nil},					-- Hymn of Hope
	{"PRIEST",		33206,	nil},					-- Pain Suppression
	{"PRIEST",		109964,	nil},					-- Spirit Shell (added in 5.0.4)
	{"PRIEST",		73325,	nil},					-- Leap of Faith
	{"PRIEST",		62618,	nil},					-- Power Word:Barrier
	{"PRIEST",		15286,	nil},					-- Vampiric Embrace
	{"PRIEST",		108968,	nil},					-- Void Shift
	{"PRIEST",		108920,	nil},					-- Void Tendrils (5.0.4)
	{"PRIEST",		113277,	nil},					-- Tranquility: Symbiosis (5.0.4)
	                                                   
	{"ROGUE",		2094,	nil},					-- Blind
	{"ROGUE",		31224,	nil},					-- Cloak of Shadows
	{"ROGUE",		57934,	nil},					-- Tricks of the Trade
	{"ROGUE",		1766,	nil},					-- Kick
	{"ROGUE",		114018,	nil},					-- Shroud of Concealment
	{"ROGUE",		76577,	nil},					-- Smoke Bomb
	                                                   
	{"SHAMAN",		2825,	"Horde"},				-- Bloodlust
	{"SHAMAN",		32182,	"Alliance"},			-- Heroism
	{"SHAMAN",		20608,	nil},					-- Reincarnation
	{"SHAMAN",		16190,	nil},					-- Mana Tide Totem
	{"SHAMAN",		98008,	nil},					-- Spirit Link Totem
	{"SHAMAN",		57994,	nil},					-- Wind Shear
	{"SHAMAN",		108280,	nil},					-- Healing Tide Totem
	{"SHAMAN",		5394,	nil},					-- Healing Stream Totem
	{"SHAMAN",		108281,	nil},					-- Ancestral Guidance
	{"SHAMAN",		2484,	nil},					-- totem nexo  
	                                                   
	{"WARLOCK",		698,	nil},					-- Ritual of Summoning
	{"WARLOCK",		29893,	nil},					-- Ritual of Souls
	{"WARLOCK",		20707,	nil},					-- Soulstone Resurrection
	                                                   
	{"WARRIOR",		871,	nil},					-- Shield Wall
	{"WARRIOR",		64382,	nil},					-- Shattering Throw
	{"WARRIOR",		12975,	nil},					-- Last Stand
	{"WARRIOR",		97462,	nil},					-- Rallying Cry
	{"WARRIOR",		6552,	nil},					-- Pummel
	{"WARRIOR",		102060,	nil},					-- Disrupting Shout
	{"WARRIOR",		114028,	nil},					-- Mass Spell Reflection
	{"WARRIOR",		114207, nil},					-- Skull Banner
	{"WARRIOR",		114203, nil},					-- Demoralizing Banner
	                                                   
	{"DEATHKNIGHT",	49576,	nil},					-- Death Grip
	{"DEATHKNIGHT",	48792,	nil},					-- Icebound Fortitude
	{"DEATHKNIGHT",	48707,	nil},					-- Anti-Magic Shell
	{"DEATHKNIGHT",	61999,	nil},					-- Raise Ally
	{"DEATHKNIGHT",	42650,	nil},					-- Army of the Dead
	{"DEATHKNIGHT",	49222,	nil},					-- Bone Shield
	{"DEATHKNIGHT",	55233,	nil},					-- Vampiric Blood
	{"DEATHKNIGHT",	46584,	nil},					-- Raise Dead
	{"DEATHKNIGHT",	51052,	nil},					-- Anti-Magic Zone
	{"DEATHKNIGHT",	47528,	nil},					-- Mind Freeze			--new
	{"DEATHKNIGHT",	47476,	nil},					-- Strangulate			--new
	{"DEATHKNIGHT",	49028,	nil},					-- Dancing Rune Weapon
	{"DEATHKNIGHT",	49039,	nil},					-- Lichborne
	{"DEATHKNIGHT",	48743,	nil},					-- Death Pact
}

--Esta variable es solo para que en configuracion de hechizos no se pueda
--seleccionar los hechizos cuyas voces no esten grabadas
local ID_HECHIZOS_NO_DESHABILITADOS = {
  740, 2484, 5215, 5394, 15286, 16190, 64901, 102280, 108280, 113277, 115310, 123904, 22812, 32182, 123904, 115176, 116849, 33206, 
  62618, 108968
}
--formulario del addon, donde se almacenan los datosque introduce el usuario en la ventana de configuración
--que no se guaradan en una savedvariables.
local formulario = {
  nombrenuevojugador = "", --Cada nuevo usuario se guarda aqui 
  jugadorseleccionado = {}, --Si en  la ventana de roster habitual seleccionas un jugador entonces  aparece su nombre aqui
  claseseleccionada = L["-- Selecciona --"],
}
-- Estrutura de datos para AceDB, esta es la estrutura de datos que usa AceDB para guardar las savedvariables
local defaults = {
  global = { 
    --Indica si el addon esta activo o no, activando o no la recepción del evento COMBAT_LOG_EVENT_UNFILTERED 
    Activo = true,
    Maestro = true, -- Usar canal Maestro o no?
    RutaVoces = "Interface\\AddOns\\VoiceCoolDown\\Voces\\",
    debugonCombat, 
    debugSonido, --Estas variables muestra informacion de depuración
  },
  profile = {
		minimap = {
			hide = false,
		},
    hechizosEnCD = {}, --Esta Variable almacena como indice el identificador del timer y el spellid que monitoriza
    hechizosMonitorizados = {}, -- Variable que contiene los idspell a monitorizar, 
                                -- contiene tb los datos que les corresponde de la ventana de configuración
                                -- Es un array de registros. donde cada registro contiene el iddelhechizo en primer lugar
                                -- luego si avisa cuando castee, su prioridad, si avisa cuando disponible, la prioridad
    rosterHabitual = {}, -- El roster guardado para el jugador. LOS CAMPOS NIL LOS TENGO PARA FUTURAS AMPLIACIONES DE OPCIONES
    numeroVocesCola =3 -- Número de voces que encola para reproducir.
	},
}

local NOMBRECLASES_LOCALIZADAS = {}
FillLocalizedClassList(NOMBRECLASES_LOCALIZADAS)

--Estructura del frame de configuracion, lo usa Ace3-Config y Ace3-ConfigDialog
local options = {
  type = "group",
  childGroups = "tab",
  args = {
    generales={
      name = L["C_N_GENERAL"],  
      desc = L["C_D_GENERAL"],
      type = "group",
      order = 0,
      args={
        activo = {
          name = L["C_N_ACTIVO"],
          desc = L["C_D_ACTIVO"],
          type = "toggle",
          order = 1,
          --width = "half",
          disabled = function()
            --Si estamos en situación de proceso de datos no debo
            --poder activar ni desactivar el addon para evitar
            --que se quede en situaciones no contempladas
            return (oVoiceCoolDown.EnCombate or oVoiceCoolDown.EnModoPrueba) 
          end,
          set = function(info, value) 
            -- Registramos o Desregistramos los eventos para activar o desactivar el addon.
            -- Cuando estemos en combate o en modo prueba esta opcion no se puede modificar
            oVoiceCoolDown.db.global.Activo = value
            if oVoiceCoolDown.db.global.Activo then 
              self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventCombatLog")
              self:RegisterEvent("GROUP_ROSTER_UPDATE","PartyMembersChanged")
              self:RegisterEvent("PLAYER_REGEN_DISABLED","EventStartCombat")
              self:RegisterEvent("PLAYER_REGEN_ENABLED","EventFinishCombat") 
            else
              self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventCombatLog")
              self:UnregisterEvent("GROUP_ROSTER_UPDATE","PartyMembersChanged")
              self:UnregisterEvent("PLAYER_REGEN_DISABLED","EventStartCombat")
              self:UnregisterEvent("PLAYER_REGEN_ENABLED","EventFinishCombat") 
            end
          end,
          get = function()
            return oVoiceCoolDown.db.global.Activo
          end
        },
        maestro = {
          name = L["C_N_MAESTRO"],
          desc = L["C_D_MAESTRO"],
          type = "toggle",
          order = 2,
          --width = "half",
          set = function(info, value) 
            -- Utiliza el canal maestro o no para las voces
            oVoiceCoolDown.db.global.Maestro = value  
          end,
          get = function()
            return oVoiceCoolDown.db.global.Maestro
          end
        },
        modoprueba = {
          name = L["C_N_MODO_PRUEBA"],
          desc = L["C_D_MODO_PRUEBA"],
          type = "toggle",
          order = 3,
          set = function(info, value) 
            oVoiceCoolDown.EnModoPrueba = value
            if oVoiceCoolDown.EnModoPrueba then 
              oVoiceCoolDown:Print(L["MODO_PRUEBA_ACTIVO"])
            else
              oVoiceCoolDown:Print(L["MODO_PRUEBA_DESACTIVADO"])
            end
          end,
          get = function()
            return oVoiceCoolDown.EnModoPrueba
          end
        },      
        numeroencola = {
          name = L["C_N_COLA"],
          desc = L["C_D_COLA"],
          type = "range",
          order = 4,
          step = 1,
          min = 2, 
          max = 10,
              
    --softMin - "soft" minimal value, used by the UI for a convenient limit while allowing manual input of values up to min/max
    --softMax - "soft" maximal value, used by the UI for a convenient limit while allowing manual input of values up to min/max
    --step - step value: "smaller than this will break the code" (default=no stepping limit)
    --bigStep - a more generally-useful step size. Support in UIs is optional.
    --get (function|methodname) - getter function
    --set (function|methodname) - setter function
    --isPercent (boolean) - represent e.g. 1.0 as 100%, etc. (default=false) 
          
          
          set = function(info, value) 
            oVoiceCoolDown.db.profile.NumeroVocesCola = value
          end,
          get = function()
            return oVoiceCoolDown.db.profile.NumeroVocesCola
          end,        
        },
        depuracion={
          name = L["C_N_DEPURACION"],
          desc = L["C_D_DEPURACION"],
          type = "group",
          inline = true,
          order = 5,
          width="full",
          args={
          
            debugsonido = {
              name = L["C_N_DEBUGSONIDO"],
              desc = L["C_D_DEBUGSONIDO"],
              type = "toggle",
              order = 1,
              set = function(info, value) 
                oVoiceCoolDown.db.global.debugSonido = value  
              end,
              get = function()
                return oVoiceCoolDown.db.global.debugSonido
              end
            },
            debugoncombat = {
              name = L["C_N_DEBUGONCOMBAT"],
              desc = L["C_D_DEBUGONCOMBAT"],
              type = "toggle",
              order = 2,
              set = function(info, value) 
                oVoiceCoolDown.db.global.debugonCombat = value  
              end,
              get = function()
                return oVoiceCoolDown.db.global.debugonCombat
              end
            },
          } 
        },
        informacion={
          name = L["C_N_INFORMACION"],
          desc = L["ADDON_DESC"],
          type = "group",
          inline = true,
          order = 6,
          width="full",
          args={
            textoinformacion={
              name = L["C_N_TEXTOINFORMACION"],
              type = "description",
              fontSize = "large",
              order = 1,
              width="full",
            },
          }
        },
        ejemplo = {
          type = "execute",
          name = L["C_N_EJEMPLO"],
          desc = L["C_D_EJEMPLO"],
          width = "full",
          order = 100,
          func = function()
            if VoiceCoolDown.db.global.Maestro then
              PlaySoundFile(VoiceCoolDown.db.global.RutaVoces.."1068068"..".mp3","Master")
            else
              PlaySoundFile(VoiceCoolDown.db.global.RutaVoces.."1068068"..".mp3")
            end  
          end,
        },
      }
    },
    hechizos={
      name = L["C_N_HECHIZOS"],
      desc = L["C_D_HECHIZOS"],
      type = "group",
      order = 1,
      args={} -- Se añaden las opciones dinamicamente en la funcion ConfigMonitorizedSpells)
    },
    roster={
      name = L["C_N_ROSTER"],
      desc = L["C_D_ROSTER"],
      type = "group",
      order = 2,
      args={
        botonesroster={
          name = L["C_N_ANADIRJUGADOR"],
          desc = L["C_D_ANADIRJUGADOR"],
          type = "group",
          inline = true,
          args={   
            selectorclase = {
              type = "select",
              name = L["C_N_CLASE"],
              order = 0,
              style = "dropdown",
              width = "normal",
              values = function()
                local values = {}
                local defecto
                values[L["-- Selecciona --"]] = L["-- Selecciona --"]
                for i, defecto in ipairs(CLASES_ENUM) do
                  clase = defecto[1]
                  colorClase = defecto[2]
                  values[clase] = colorClase..NOMBRECLASES_LOCALIZADAS[clase]
                end
                return values
              end,
              get = function(info) 
               --VoiceCoolDown:Print(formulario.claseseleccionada)
               return formulario.claseseleccionada
              end,
              set = function(info, value) formulario.claseseleccionada = value end,
            },
            NombreNuevoMiembro = {
              type = "input",
              name = L["C_N_ENTRADAJUGADOR"],
              desc = L["C_D_ENTRADAJUGADOR"],
              order = 1,
              width = "normal",
              get = function(info)
                if(formulario.nombrenuevojugador ~= nil) then return formulario.nombrenuevojugador
                else return "" end
              end,
              set = function(info, value)
					     formulario.nombrenuevojugador = strtrim(value)					
              end,
            },
            AnadirMiembroBoton = {
              type = "execute",
              name = L["C_N_ANADIRJUGADOR"],
              desc = L["C_D_ANADIRJUGADOR"],
              width = "normal",
              order = 2,
              func = function()
                if VoiceCoolDown:AddPlayerHabitualRoster({formulario.nombrenuevojugador, formulario.claseseleccionada, nil, nil}) then 
                  formulario.nombrenuevojugador = ""
                  formulario.claseseleccionada = L["-- Selecciona --"]
                end
                ACR:NotifyChange("VoiceCoolDown")
                VoiceCoolDown:ConfigHabitualRoster()
              end,
              disabled = function()
                if (formulario.claseseleccionada == L["-- Selecciona --"]) or 
                   (formulario.nombrenuevojugador == "") then 
                    return true 
                end
              end,
            },
            AnadirBandaBoton = {
              type = "execute",
              name = L["C_N_ANADIRJUGADORESGRUPO"],
              desc = L["C_D_ANADIRJUGADORESGRUPO"],
              width = "normal",
              order = 3,
              func = function()
                
              end,
              disabled = function()
                
              end,
            },
            BorrarBandaBoton = {
              type = "execute",
              name = L["C_N_BORRARJUGADOR"] ,
              desc = L["C_D_BORRARJUGADOR"] ,
              width = "normal",
              order = 4,
              func = function()
                
              end,
              disabled = function()
                
              end,
            },
          } 
        },
        cuerporoster={
          name = "Lista roster",
          --desc = L["C_D_ROSTER"],
          type = "group",
          inline = true,
          width = "full",
          args={} -- Se añaden las opciones dinamicamente en la funcion ConfigMonitorizedSpells)
        }
      } 
    }
  }
}


--Variables que no es necesario guardar cada vez que conectas/desconectas SAVEDVARIABLES
VoiceCoolDown.Hablando = {} -- Para evitar reproducir dos cooldown simultaneos y que se superpongan, esta variable lo controla
VoiceCoolDown.HoraComienzoCombateActual = time() --Contiene la hora a la que comienza el combate actual
VoiceCoolDown.HoraFinCombateActual = time()      --Contiene la hora a la que termina el combate actual
VoiceCoolDown.TiempoTotalCombateActual = time()  --Duración del combate actual
VoiceCoolDown.EnCombate = false --Esta variable determina si estamos en combate o no
VoiceCoolDown.EnModoPrueba = false --Esta claro no? sino lo ves dedicate a otra cosa.... 
VoiceCoolDown.MinimapButton = nil --Contendra un objeto LDB que definira los parametro del boton del minimapa
VoiceCoolDown.MinimapButtonIcon = nil --Contendra el objeto que crea un boton del minimapa a partir del objeto LDB anterior
VoiceCoolDown.db = nil --Contiene el objeto que almacena los datos de configuración para savedvariables.



function VoiceCoolDown:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("VoiceCoolDownDB", defaults) --Recupera datos guardados de la anterior sesión
  
  self:ConfigHabitualRoster() --Leer comentario de la siguiente, solo que carga el roster habitual en options
  self:ConfigMonitorizedSpells() --Esta linea debe de ir antes que la siguiente ya que carga adecuadamente el parametro "options"
  LibStub("AceConfig-3.0"):RegisterOptionsTable("VoiceCoolDown", options, "cvdconfig")
  LibStub("AceConfigDialog-3.0"):AddToBlizOptions("VoiceCoolDown")
  LibStub("AceConfigDialog-3.0"):SetDefaultSize("VoiceCoolDown",800,420)
  --self:RegisterChatCommand("TBRWipe","RLWipe") --El RL mediante este comando indica que ha decidido wipe para el encuentro y se deja de tomar datos
  self:RegisterChatCommand("VCDShowIcon","ShowIcon") --Muestra u oculta el icono del minimapa.
  self:RegisterChatCommand("VCD",function() self:Print( L["ADDON_DESC"])  end)
  self:CreateMinimapButton()
end

function VoiceCoolDown:OnEnable()
--Este evento se produce cuando el addon ya esta cargado
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventCombatLog")
  --self:RegisterEvent("ZONE_CHANGED_NEW_AREA","DetectInstanceChange") --Si cambia de instancia -> reset de la tabla almacenada?
  self:RegisterEvent("GROUP_ROSTER_UPDATE","PartyMembersChanged") --Si hay modificaciones en el grupo tengo que recalcular la estructura del grupo
  self:RegisterEvent("PLAYER_REGEN_DISABLED","EventStartCombat") --Este evento se produce cuando el jugador entra en combate
  self:RegisterEvent("PLAYER_REGEN_ENABLED","EventFinishCombat") --Este evento se produce cuando el jugador entra en combate
end

function VoiceCoolDown:EventEndTimer(HechizoID)
  
  local nombreHechizo = GetSpellInfo(HechizoID)
  
  if self.db.global.debugonCombat then
    self:Print("|cffffff00-------------------")
    self:Print("|cffffff00Disponible de nuevo "..HechizoID)
    self:Print(HechizoID.." "..nombreHechizo) 
  end
  self:PlaySoundFile(nil, nil, "disponible",tostring(HechizoID))
end
function VoiceCoolDown:EventCombatLog(event, ...)
--Esta función se activa cuando se dispara un evento de COMBAT_LOG_EVENT_UNFILTERED

  local idTimer
  local timestamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, srcFlags2, destGUID, destName, destFlags, destFlags2, spellID, spellName = select(1, ...)
  local tiempoCD
  local postCD = false
  local indiceHechizo --Si el el spell hay que monitorizarlos llamare a IsMonitorizedSpell 
                      --que indicara en que posicion del array que los almacena esta
  
  if not self:QProcessEventCombat() then return end
    
  if self:IsPlayerInGroup(sourceName) or --Si es alguien del grupo ó.....
     (self.EnModoPrueba and (sourceGUID == UnitGUID("player"))) then --ó Si soy yo y estoy modoprueba
    indiceHechizo = self:IsMonitorizedSpell(spellID)
    if indiceHechizo > 0 then --Si esta en la lista de hechizos a monitorizar
      -- Recupero el cooldown del hechizo
      -- y si es un hechizo que el cooldown comoienza cuando desaparezca el efecto del hechizo 
      -- ->que el dato recuperado vendra en negativo.
      tiempoCD = VoiceCoolDown.SPELL_MONITOR_SCHEMA.cooldowns[spellID]
     
      if tiempoCD < 0 then 
        tiempoCD = -1*tiempoCD
        postCD = true
      end
      if self.db.global.debugonCombat then
        self:Print("|cffffff00-------------------")
        self:Print(ChatFrame1,"|cffffff00"..spellID.." "..spellName)
        self:Print(ChatFrame1,eventType)
        self:Print("TiempoCD: "..tiempoCD)
      end
      if eventType == "SPELL_CAST_SUCCESS" then
        --¿Debo de avisar cuando se lance el hechizo?
        if self.db.profile.hechizosMonitorizados[indiceHechizo][2] then
          self:PlaySoundFile(nil, sourceName,"lanzo",tostring(spellID))
        end
        if not postCD and self.db.profile.hechizosMonitorizados[indiceHechizo][4] then 
          idTimer = self:ScheduleTimer("EventEndTimer", tiempoCD, spellID)
        end
      elseif eventType == "SPELL_AURA_REMOVED" then
        if postCD and self.db.profile.hechizosMonitorizados[indiceHechizo][4] then 
          idTimer = self:ScheduleTimer("EventEndTimer", tiempoCD, spellID)
        end
      end
    end
  end
end
function VoiceCoolDown:EventStartCombat()
--Esta funcion recoge el disparo del evento PLAYER_REGEN_ENABLED y se limita a llamar
--a la función StartCombat que es la que inicializa todo lo necesario cuando comienza
--un combate.

  self:StartCombat()
end
function VoiceCoolDown:EventFinishCombat()
--Esta funcion recoge el disparo del evento PLAYER_REGEN_DISABLED y se limita a llamar
--a la función FinishCombat que es la que calcula y procesa todo lo necesario cuando ha
--terminado un combate.

  self:FinishCombat()
end
function VoiceCoolDown:StartCombat()
--Esta función inicia las variables necesarias cuando comienza el combate, 
--es llamada en el programa cuando se detecta el inicio de un combate

  self.HoraComienzoCombateActual = time() --Establece la hora de comienzo del combate
  self.EnCombate = true --La funcion que procesa los eventos de combate usa esta variable para recoger o no datos
  
end
function VoiceCoolDown:FinishCombat()
--Esta funcion determina establece las variables necesarias cuando termina un combate
--y realiza los calculos necesarios al finalizar un combate.

  self.EnCombate = false --La funcion que procesa los eventos de combate usa esta variable para recoger o no datos
  self.HoraFinCombateActual = time() --Establece la hora de fin del combate
  self.TiempoTotalCombateActual = self.HoraFinCombateActual-self.HoraComienzoCombateActual
  self:Print(date("Tiempo total de combate is %M:%S",self.TiempoTotalCombateActual))
end
function VoiceCoolDown:ShowIcon()
  self:Print( self.db.profile.minimap.hide)
  self.db.profile.minimap.hide = not self.db.profile.minimap.hide
	if self.db.profile.minimap.hide then
		self.MinimapButtonIcon:Hide("VoiceCoolDown!")
	else
    self.MinimapButtonIcon:Show("VoiceCoolDown!")
	end
  self:Print( self.db.profile.minimap.hide)
end

function VoiceCoolDown:CheckForWipe()
--Determina si ha habido wipe
	local wipe = true
	local num = GetNumGroupMembers()
	for i = 1, num do
		local name = GetRaidRosterInfo(i)
		if name then
			if UnitAffectingCombat(name) ~= nil then
				wipe = false
			end
		end
	end
	return wipe
end


function VoiceCoolDown:PartyMembersChanged()
--Esta función se ejecuta solo si se dispara el evento de GROUP_ROSTER_UPDATE
end
function VoiceCoolDown:GetGroupTypeAndCount()
--Determina el tipo de grupo: Party ó Raid y el número de miembros

	local type = "none"
	local count = GetNumGroupMembers()
	if IsInRaid() then
		type = "raid"
	elseif IsInGroup() then
		type = "party"
	end
  return type, count
end
function VoiceCoolDown:CreateMinimapButton()
--Utiliza para ello las librerias LDB y LDBI, crea un objeto
--LDB y lo registra como un icno del minimapa a través
--de un objeto LDBI
	local LDB = LibStub("LibDataBroker-1.1", true)
	if not LDB then return end
	self.MinimapButton = LDB:NewDataObject("VoiceCoolDown!", {
		type = "launcher",
		text = "VoiceCoolDown!",
		icon = "Interface\\AddOns\\VoiceCoolDown\\Images\\TBRMinimapButton",
		OnClick = function(_, button)
      --self:Print("|cffffff00----------------------------------")
      if button == "RightButton" then 
        if self:IsConfigWindowOpen() then return end
        self.EnModoPrueba = not self.EnModoPrueba
        if self.EnModoPrueba then 
          self:Print(L["MODO_PRUEBA_ACTIVO"])
        else
          self:Print(L["MODO_PRUEBA_DESACTIVADO"])
        end
      elseif button == "LeftButton" then 
        if self:IsConfigWindowOpen() then return end
        if self.db.global.debugonCombat or self.db.global.debugSonido then
          self.db.global.debugonCombat = false
          self.db.global.debugSonido = false
          self:Print(L["DEPURAR_DESACTIVADO"])
        else
          self.db.global.debugonCombat = true
          self.db.global.debugSonido = true
          self:Print(L["DEPURAR_ACTIVO"])
        end
      else
        if self:IsConfigWindowOpen() then 
          ACD:Close("VoiceCoolDown")
        else
          ACD:Open("VoiceCoolDown")
        end
      end
    end,
    OnTooltipShow = function(tt)
      tt:AddLine("VoiceCoolDown")
      tt:AddLine("|cffffff00" .. L["TOOLTIP_MINIMAP"])
      tt:AddLine("|cffffff00" .. L["TOOLTIP2_MINIMAP"])
      tt:AddLine("|cffffff00" .. L["TOOLTIP3_MINIMAP"])
    end,
	})
	self.MinimapButtonIcon = LibStub("LibDBIcon-1.0", true)
	if self.MinimapButtonIcon then self.MinimapButtonIcon:Register("VoiceCoolDown!", self.MinimapButton, self.db.profile.minimap) end
end
function VoiceCoolDown:QProcessEventCombat()
--Esta función determina si hay que guardar el evento de combate. Es llamada en EventCombatLog
--Si devuelve true -> Procesa el evento de combate en curso.

  return  (self.EnCombate or self.EnModoPrueba)
end
function VoiceCoolDown:IsMonitorizedSpell(IDHechizo)
--Comprueba que el hechizo que se ha pasado por argumento este en la lista de hechizos a procesar en el combat log
--Esta funcion se llama desde la funcion que responde a los eventos de combat log

  --if self.db.global.debugSonido or self.db.global.debugonCombat then
  --  self:Print("|cffffff00-------------------")
   -- self:Print("|cffffff00IsMonitorizedSpell: " ..IDHechizo)
  --  self:Print("|cffffff00Número de hechizos: "..tostring(#self.db.profile.hechizosMonitorizados))
  --end
  if #self.db.profile.hechizosMonitorizados <= 0 then return 0 end
  for i, defecto  in ipairs(self.db.profile.hechizosMonitorizados) do
    --if self.db.global.debugSonido or self.db.global.debugonCombat then
    --  self:Print("|cffffff00hechizo en lista: "..i.." "..defecto[1])
    --end
    if defecto[1] == IDHechizo then 
    --  if self.db.global.debugSonido or self.db.global.debugonCombat then
    --    self:Print("|cffffff00Posición: " ..i)
    --  end
      return i 
    end -- La primera posición contiene el hechizoID
  end
  return 0
end
function VoiceCoolDown:DelMonitorizedSpell(HechizoID)
--Elimina el spell pasado por parametro de la lista de hechizos a monitorizar
 
  i = self:IsMonitorizedSpell(HechizoID)
  if i > 0 then 
    table.remove(self.db.profile.hechizosMonitorizados, i)
  end
end
function VoiceCoolDown:AddMonitorizedSpell(HechizoID)
--Mete el spell pasado por parametro en la lista de hechizos a monitorizar

  if (self:IsMonitorizedSpell(HechizoID) == 0) then
    table.insert(self.db.profile.hechizosMonitorizados,{HechizoID, true, 1, true, 1})
  end
end
function VoiceCoolDown:IsPlayerHabitualRoster(NombreJugador)
--Comprueba si el jugador pasado por arg esta ya en self.db.profile.rosterHabitual
  
  if #self.db.profile.rosterHabitual <= 0 then return false end
  for i, defecto in ipairs(self.db.profile.rosterHabitual) do
    if defecto[1] == NombreJugador then return true end
  end
  return false
end
function VoiceCoolDown:AddPlayerHabitualRoster(RegistroJugador)
--Mete el nuevo jugador en self.db.profile.rosterHabitual

  if self:IsPlayerHabitualRoster(RegistroJugador[1]) then return false end --Si existe me las piro y devuelvo que no pude añadir
  table.insert(self.db.profile.rosterHabitual, RegistroJugador) -- Añado el jugador a la tabla
  return true -- Devuelvo exito
end
function VoiceCoolDown:IsPlayerInGroup(jugador)
--Esta función determina si username esta en banda, si es así procesara los spell del combat log
  
  local tipo -- Tipo de grupo = "party" o "banda" 
  local numero -- Cantidad de miembros en el grupo

  if not self:QProcessEventCombat() then return nil end --Si no esta en modo procesamiento -> No hay que comprobar
  
  tipo, numero = self:GetGroupTypeAndCount()
  if numero > 0 then 
    for i = 1, numero do 
      if jugador == GetRaidRosterInfo(i) then return true end
    end
  end
  return  false
end

function VoiceCoolDown:IsConfigWindowOpen()
--Es una función que determina si la ventana de configuración esta abierta
--Para ello accede a la estrucutura interna de Ace-ConfigDialog que no esta documentada
--Esta libreria Ace lleva desde 2009 sin cambios por lo que no es probable que cambie.

  if ACD.OpenFrames["VoiceCoolDown"] ~= nil then 
    return true 
  else
    return false
  end
end;
function VoiceCoolDown:IsPlayerSelect(jugador) 
--Esta en jugador seleccionado en la ventana de roster habitaul de configuración
--Si lo esta -> aparece en formulario.jugadorseleccionado. 
  
  if #formulario.jugadorseleccionado <= 0 then return false end
  for i,v in ipairs(formulario.jugadorseleccionado) do
    if v == jugador then return true end
  end
  return false
end
function VoiceCoolDown:AddDelPlayerSelect(jugador,borrar)
--Si borrar borra el jugador de la lista de jugadores seleccionados
--en caso contrario lo añade
  
  if borrar then
    if not self:IsPlayerSelect(jugador) then  
     formulario.jugadorseleccionado[#formulario.jugadorseleccionado+1] = jugador
    end   
  else
    for i, v in ipairs(formulario.jugadorseleccionado) do
      if v == jugador then table.remove(formulario.jugadorseleccionado, i) end
    end 
  end
end
function VoiceCoolDown:ConfigHabitualRoster()
--Esta función lo que hace es construir dinamicamente 
--la lista de jugadores del roster habitual

  local lRoster = options.args.roster.args.cuerporoster.args --Camino rapido para escribir menos :)
  local nombrejugador
  local clase
  local colorclase --el color de la clase del jugador en formato |cffffff00

  if self.db.profile.rosterHabitual == nil then return end
  
  --Este bucle construye las barras para cada jugador del roster
  --que contendra su nombre y botones asociados
  for i, defecto in ipairs(self.db.profile.rosterHabitual) do
    nombrejugador = defecto[1]
    clase = defecto[2]
    lRoster["barra_"..nombrejugador] = {
      name = "",
      type = "group",
      inline = true,
      args = {}
    }
    for i2, defecto2 in ipairs(CLASES_ENUM) do
      if defecto2[1] == clase then colorclase = defecto2[2] end
    end      
    lRoster["barra_"..nombrejugador].args[nombrejugador] = {
      name = colorclase..nombrejugador,
      type = "toggle",
      order = 1,
      get = function(info)
        if self.db.debug then self:Print("The " .. info[#info]) end
        return self:IsPlayerSelect(info[#info])
      end,
      set = function(info, value)
        if self.db.debug then self:Print("The " .. info[#info] .. " was set to: " .. tostring(value) ) end
        self:AddDelPlayerSelect(info[#info],value)	
				if self.db.global.Maestro then
          PlaySoundFile(self.db.global.RutaVoces..info[#info]..".mp3","Master")
        else
          PlaySoundFile(self.db.global.RutaVoces..info[#info]..".mp3")
        end
      end,
    }
    
    
    lRoster["barra_"..nombrejugador].args["invita_"..nombrejugador] = {
      name = L["C_N_INVITA"], 
      desc = L["C_D_INVITA"],
      type = "execute",
      width = "normal",
      order = 3,
      func = function()
              
      end,
      disabled = function()
                
      end,
    }
    lRoster["barra_"..nombrejugador].args["autoinvita_"..nombrejugador] = {
      name = L["C_N_AUTOINVITA"], 
      desc = L["C_D_AUTOINVITA"],
      type = "toggle",
      width = "normal",
      order = 3,
      get = function(info)
      --          if(formulario.nombrenuevojugador ~= nil) then return formulario.nombrenuevojugador
      --          else return "" end
      end,
      set = function(info, value)
      --formulario.nombrenuevojugador = strtrim(value)					
      end,
    }
  end


end
function VoiceCoolDown:ConfigMonitorizedSpells()
--Esta función lo que hace es construir dinamicamente 
--las opciones de configuración de hechizos.
  
  local lHechizos, lHechizos2
  local claseNombre
  
  for claseEnum, defecto in ipairs(CLASES_ENUM) do
    claseNombre = defecto[1]
    options.args.hechizos.args[claseNombre] = {
      name = L[claseNombre],
      type = "group",
      args={}
    }
    lHechizos = options.args.hechizos.args[claseNombre]
    for i, defecto in ipairs(HECHIZOS_PORDEFECTO) do 
      local clase = defecto[1]
      local spellid = defecto[2]
      local alliance = defecto[3]
      
      if clase == claseNombre then 
        lHechizos.args[tostring(spellid)] = {
          name = "",
          type = "group",
          inline = true,
          args = {}
        }
        lHechizos2 = lHechizos.args[tostring(spellid)]
        lHechizos2.args["sel"..tostring(spellid)] = {
          name = GetSpellInfo(spellid),
          type = "toggle",
          order = 1,
          set = function(info, value) 
            if value then 
              oVoiceCoolDown:AddMonitorizedSpell(tonumber(info[#info-1]))
            else 
              oVoiceCoolDown:DelMonitorizedSpell(tonumber(info[#info-1])) 
            end
            if oVoiceCoolDown.db.global.Maestro then
              PlaySoundFile(self.db.global.RutaVoces..info[#info-1]..".mp3","Master")
            else
              PlaySoundFile(self.db.global.RutaVoces..info[#info-1]..".mp3")
            end
          end,
          get = function(info)
            return (oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) > 0) 
          end,
          disabled = function(info)
            for i,v in ipairs(ID_HECHIZOS_NO_DESHABILITADOS) do
              if v == tonumber(info[#info-1])then return false end
            end
            return true
          end,
        }
        lHechizos2.args["lanza"..tostring(spellid)] = {
          name = "Castea",
          type = "toggle",
          order = 2,
          width ="half",
          set = function(info, value)
            -- Este Togle de configuración se corresponde con si se debe de anunciar el casteo del hechizo
            -- 1º Obtengo la posición donde estan estos datos para el spell de self.db.profiles.hechizosMonitorizados
            -- 2º Obtengo un puntero a todo el registro para esa spell
            -- 3º Me voy a la posición 2 que es donde se almacena el valor de este togle
            i = oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) 
            hechizo = oVoiceCoolDown.db.profile.hechizosMonitorizados[i] 
            hechizo[2] = value
          end,
          get = function(info)
            local hechizo = {}
            local i
            -- info[#info-1] es referecencia al nivel anterior, que tiene como nombre el id del spell
            i = oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) 
            if i > 0 then
              hechizo = oVoiceCoolDown.db.profile.hechizosMonitorizados[i]   -- Muy parecido a set
              return hechizo[2]
            end
            return false
          end,
          disabled = function(info)
            return (oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) == 0) --Si el spell no esta seleccicçonado -> disabled
          end,
        }
        lHechizos2.args["prilanza"..tostring(spellid)] = {
          type = "select",
          name = "Pri",
          order = 3,
          style = "dropdown",
          width = "half",
          values = function()
            local values = {}
            values[1] = "Alta"
            values[2] = "Media"
            values[3] = "Baja"
            return values
          end,
          set = function(info, value)
            -- Este Togle de configuración se corresponde con si se debe de anunciar el casteo del hechizo
            -- 1º Obtengo la posición donde estan estos datos para el spell de self.db.profiles.hechizosMonitorizados
            -- 2º Obtengo un puntero a todo el registro para esa spell
            -- 3º Me voy a la posición 2 que es donde se almacena el valor de este togle
            i = oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) 
            hechizo = oVoiceCoolDown.db.profile.hechizosMonitorizados[i] 
            hechizo[3] = value
          end,
          get = function(info)
            local hechizo = {}
            local i
            -- info[#info-1] es referecencia al nivel anterior, que tiene como nombre el id del spell
            i = oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) 
            if i > 0 then
              hechizo = oVoiceCoolDown.db.profile.hechizosMonitorizados[i]   -- Muy parecido a set
              return hechizo[3]
            end
            return false
          end,          
          disabled = function(info)
            return (oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) == 0) --Si el spell no esta seleccicçonado -> disabled 
          end,
        }
        lHechizos2.args["dispo"..tostring(spellid)] = {
          name = "Disponible",
          type = "toggle",
          order = 4,
          width ="half",
          set = function(info, value)
            -- Este Togle de configuración se corresponde con si se debe de anunciar la disponibilidad del hechizo
            -- 1º Obtengo la posición donde estan estos datos para el spell de self.db.profiles.hechizosMonitorizados
            -- 2º Obtengo un puntero a todo el registro para esa spell
            -- 3º Me voy a la posición 2 que es donde se almacena el valor de este togle
            i = oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) 
            hechizo = oVoiceCoolDown.db.profile.hechizosMonitorizados[i] 
            hechizo[4] = value
          end,
          get = function(info)
            local hechizo = {}
            local i
            -- info[#info-1] es referecencia al nivel anterior, que tiene como nombre el id del spell
            i = oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) 
            if i > 0 then
              hechizo = oVoiceCoolDown.db.profile.hechizosMonitorizados[i]   -- Muy parecido a set
              return hechizo[4]
            end
            return false
          end,
          disabled = function(info)
            return (oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) == 0) --Si el spell no esta seleccicçonado -> disabled
          end,
        }
        lHechizos2.args["pridispo"..tostring(spellid)] = {
          type = "select",
          name = "Pri",
          order = 5,
          style = "dropdown",
          width = "half",
          values = function()
            local values = {}
            values[1] = "Alta"
            values[2] = "Media"
            values[3] = "Baja"
            return values
          end,
          set = function(info, value)
            -- Este Togle de configuración se corresponde con si se debe de anunciar el casteo del hechizo
            -- 1º Obtengo la posición donde estan estos datos para el spell de self.db.profiles.hechizosMonitorizados
            -- 2º Obtengo un puntero a todo el registro para esa spell
            -- 3º Me voy a la posición 2 que es donde se almacena el valor de este togle
            i = oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) 
            hechizo = oVoiceCoolDown.db.profile.hechizosMonitorizados[i] 
            hechizo[5] = value
          end,
          get = function(info)
            local hechizo = {}
            local i
            -- info[#info-1] es referecencia al nivel anterior, que tiene como nombre el id del spell
            i = oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) 
            if i > 0 then
              hechizo = oVoiceCoolDown.db.profile.hechizosMonitorizados[i]   -- Muy parecido a set
              return hechizo[5]
            end
            return false
          end,
          disabled = function(info)
            return (oVoiceCoolDown:IsMonitorizedSpell(tonumber(info[#info-1])) == 0) --Si el spell no esta seleccicçonado -> disabled 
          end,
        }        

      end
    end
  end 
end
function VoiceCoolDown:EventFinReproduccionCD(token)
--Esta función se ejecuta cada vez que se termina una reproducción y lo que hace
--es indicar que ya termino la reproducción eliminando de hablando el token que se genero

  local primero = self.Hablando[1]
  if self.db.global.debugSonido then self:Print("|cffffff00-------------------") end
  
  if primero[1] ~= token then 
    self:Print("Error") 
  end
  if self.db.global.debugSonido then
    self:Print("|cffffff00EventFinReproduccion "..tostring(primero[4]))
    self:Print("Tokens eliminados")
    self:Print("1 ".." "..tostring(primero[1]).." "..tostring(primero[2]).." "..tostring(primero[3]).." "..tostring(primero[4]))
    self:Print("Antes borrar - numero de tokens en la lista:"..#self.Hablando)
  end
  table.remove(self.Hablando,1)
  if self.db.global.debugSonido then
    self:Print("Despues borrar - numero de tokens en la lista:"..#self.Hablando)
    self:Print("Tokens que quedan")
    for i,defecto in ipairs(self.Hablando) do
      self:Print(i.." "..tostring(defecto[1]).." "..tostring(defecto[2]).." "..tostring(defecto[3]).." "..tostring(defecto[4]))
    end
  end  
end
function VoiceCoolDown:ExistTokenPlay(token)
--Comprueba si el token de reproducción esta en la lista de token de reproducción  
  
  for i, defecto in ipairs(self.Hablando) do
    if defecto[1] == token then return i end
  end
  return nil
end
function VoiceCoolDown:EventRetryPlay(token)
--Este evento se produce y salta cuando termina el tiempo asignado para vover a intentar una reproducción encolada   
  
  local jugador, accion, hechizoID
  local datosreproducciontoken
  
  if self.db.global.debugSonido then
    self:Print("|cffffff00EventRetryPlay-------------------")
    self:Print(type(token))
  end
  
  --En que linea de self.Hablando se encuentra el token 
  --y demas datos de esta reproducción retrasada
  datosreproducciontoken = self.Hablando[self:ExistTokenPlay(token)]
  if self.db.global.debugSonido then
    self:Print("|cffffff00EventRetryPlay "..datosreproducciontoken[4])
    self:Print(tostring(datosreproducciontoken[2]), 
               tostring(datosreproducciontoken[3]), 
               tostring(datosreproducciontoken[4]), 
               tostring(datosreproducciontoken[1]))
  end
  self:PlaySoundFile(datosreproducciontoken[1], 
                     datosreproducciontoken[2], 
                     datosreproducciontoken[3], 
                     datosreproducciontoken[4])
end
function VoiceCoolDown:EventPlaySound(fichero)
--Reproduce el fichero de sonido que se envia por parametro
--teniendo en cuenta la configuración del usuario sobre el 
--canal maestro
  if self.db.global.Maestro then
    PlaySoundFile(self.db.global.RutaVoces..fichero..".mp3","Master")
  else
    PlaySoundFile(self.db.global.RutaVoces..fichero..".mp3")
  end
end
SortQueueSound = function(a, b)
--OJO Esta funcion no ordena sola directamente si no que es la funcion comparadora para
--el metodo sort de lua que espera para el segundo argumento el nombre de esta función SortQueueSound
  if a[6] == 0 then return true end --En la pos 6 siempre va el id del timer, pero si va un cero -> es el que se esta reproduciondo ahora
  if b[6] == 0 then return false end -- lo mismo para b.
  if a[5] == b[5] then  --Si tienen la misma prioridad
    if a[1] < b[1] then --a ira antes que b si a es mas antiguo q b (los token son una ref temporal al momento de arranque del ordenador
      return true
    else
      return false
    end
  elseif a[5] < b[5] then --Si tiene distinta prioridad, entonces true si a debe ir antes que b que es cuando a tiene mas prioridad que b
    return true
  else
    return false
  end
end
function VoiceCoolDown:QueueSound(token, jugador, accion, hechizoID, prioridad)
--Esta funcion dado un intento de reproducción debera:
--CASO 1º Comprobar si esta -> Devuelve 1
--CASO 2º Comprobar si hay espacio para ella y si lo hay -> Devuelve 2 y se encola
--CASE 3º Si no tiene espacio entonces verifica si tiene mas prioridad que alguno que ya esta en la cola -> Si la tiene devuelve 3,
--        elimina la mas baja y cancela su temporizador por ultimo se encola ella misma
--CASO 4º Devuelve 0 y no se encolara
--En todo caso devuelve la posición en la cola y si no es de 1 a 3 -> devuelve nil

  local posicion --Posición en la que esta en la cola el item a procesar

  --Caso 1º
  if token ~= nil then 
    posicion = self:ExistTokenPlay(token)
    if posicion ~= nil then return 1, posicion end --Lo encontro devuelve 1, y la posición en la que se encuentra
  end
  --Tanto para el Caso 2, 3, 4 en todos tiene que generar un nuevo token, añadir el registro a la cola y ordenar
  --Puede que trabajemos en valde porque resulta que el nuevo elemento sea el mas bajo en prioridad y lo eliminemos
  --pero simplifica el algoritmo
  token = tostring(GetTime()) --Genera el token nuevo.
  table.insert(self.Hablando,{token, jugador, accion, hechizoID, prioridad, nil})
  table.sort(self.Hablando,SortQueueSound)  -- y lo ordena
  
  if self.db.global.debugSonido and #self.Hablando > 0 then
    self:Print("|cffffff00Lista ordenada:")
    for i, v in ipairs(self.Hablando) do
      self:Print(i.." "..v[1].." "..v[4].." "..GetSpellInfo(v[4]).." "..v[5])
    end
  end
  
  --calcula la posición en la que se encuentra el elemento
  posicion = self:ExistTokenPlay(token)
  
  if #self.db.profile.hechizosMonitorizados > 4 then error(L["ERROR2"]) end --Nunca debería de haber mas de 4 hechizos encolados
  
  --Caso 2º -> Hay espacio en la cola y devuelve 2 y el nuevo token
  if #self.Hablando <= 2 then return 2, posicion  end
  -- Caso 3º -> No hay espacio. Simplemente hay que eliminar el último, pero si el ultimo 
  --            no es el nuevo que pusimos -> cancelamos su temporizador
  if #self.Hablando > 2 then
    if self.Hablando[3][1] == token then -- este seria el caso 4, el ultimo en la cola es el nuevo y hay que borrarlo y devolver 4
      table.remove(self.Hablando, 3)
      return 0, nil
    else -- Como el nuevo, tiene mas priridad no esta en 4 lugar en la lista -> hay que cancelar el temporizador del 4
      self:CancelTimer(self.Hablando[3][6]) -- el ultimo registro en la cola debe ser el 4. en la pos 6 encontramos el puntero
      table.remove(self.Hablando, 3)
      return 3, posicion
    end
  end
end
function VoiceCoolDown:PlaySoundFile2(token, jugador, accion, hechizoID)
--Reproduce el fichero indicado de la ruta indicada pero tiene en cuenta
--si el usuario quiere que sea por el canal maestro ó no.  
--Si ya hay 2 CD esperando a ser reproducidos no encola ninguno mas
--Introduce en hablando un identificador único de la reproducción de este CD
--uso como indentificador unico de est reproducción el tiempo trasncurrido desde que arranco el ordenador = GetTime()


--Cuando a wow le dices que reproduzca 2 o mas ficheros de sonido lo que hace
--es que los supuerpone -> que tengo que usar temporizadores para que cada
--uno empieze despues del siguiente
  local idTimer  --Temporizador para empezar a reproducir 2º sonido de la frase
  local idTimer2 --Temporizador para reproducir 3er sonido de la frase
  
  local idTimer3 --Espera a que haya reproducido todo para permitir nuevas reproduciones
  local idTimer4 --Temporizador para el retraso de la reproducción.
  
  local primerareproduccion = false
  local datosreproduccion
  local primertoken -- Primer toque de la lista
  
  if self.db.global.debugSonido then
    self:Print("|cffffff00-------------------")
    self:Print("|cffffff00PlaySoundFile "..tostring(hechizoID))
  end
  
  if token == nil then
    primerareproduccion = true
    token = tostring(GetTime()) --Identificador de esta llamada a la función y por tanto de una reproducción de sonido de un CD en particular
  end
  
  if self.db.global.debugSonido then 
    self:Print(tostring(jugador).." "..tostring(accion).." "..tostring(hechizoID).." "..tostring(token))
  end
  
  datosreproduccion = {token, jugador, accion, hechizoID}
  
  --Si ya hay hablando 2 cooldown y este no es uno de los que ya esta en la lista de espera 
  --comprobara si tiene mas prioridad y lo sustituira en ese caso
  --en caso contrario nunca se reproducira
  if self.db.global.debugSonido then self:Print("ENTRANDO - numero de tokens en la lista:"..tostring(#self.Hablando)) end
  if (#self.Hablando > 2) and primerareproduccion then --(self:ExistTokenPlay(token) ~= nil) 
    if self.db.global.debugSonido then self:Print("Me las piro vampiro") end
    return 
  end 
 
  --Si el token ya esta en la lista -> que es un reintento de reproducción
  --pero si no esta como es uno nuevo lo añade a la lista de espera
  if primerareproduccion then --(self:ExistTokenPlay(token) == nil)
    if self.db.global.debugSonido then self:Print("Nuevo sonido") end
    table.insert(self.Hablando,datosreproduccion)
  end
  primertoken = self.Hablando[1]
  if primertoken[1] ~= token then -- No soy el primero -> Encolo
    if self.db.global.debugSonido then self:Print("Encolo") end
    idtimer4 = self:ScheduleTimer("EventRetryPlay", 1.50, token)
    return
  end
  
  if self.db.global.debugSonido then
    self:Print("Tokens en la lista")
    for i,defecto in ipairs(self.Hablando) do
      self:Print(i.." "..tostring(defecto[2]).." "..tostring(defecto[3]).." "..tostring(defecto[4]).." "..tostring(defecto[1]))
    end
  end
  if jugador == nil then
    if self.db.global.Maestro then
      PlaySoundFile(self.db.global.RutaVoces..accion..".mp3","Master")
    else
      PlaySoundFile(self.db.global.RutaVoces..accion..".mp3")
    end
    idTimer = self:ScheduleTimer("EventPlaySound", 0.45, hechizoID)
    idTimer3 = self:ScheduleTimer("EventFinReproduccionCD", 1.45, token)
  else
    if self.db.global.Maestro then
      PlaySoundFile(self.db.global.RutaVoces..jugador..".mp3","Master")
    else
      PlaySoundFile(self.db.global.RutaVoces..jugador..".mp3")
    end
    --idTimer = self:ScheduleTimer("EventPlaySound", 0.45, accion) --Por ahora no lo voy a usar para que sea mas corta la frase,     
                                                                   --suma 0,45 a cada timer de abajo si activas esto
    idTimer2 = self:ScheduleTimer("EventPlaySound", 0.45, hechizoID)
    --Transcurrido este tiempo sabe que ya ha terminado esta reproducción por eso hay timer con un evento 
    --que borra el token de la lista que hay en reproducción. El tiempo es la suma de lo que tarda en decir
    --Jugador+Acción+Hehcizo = 0.45 +0.45 + 1 = 1.90
    idTimer3 = self:ScheduleTimer("EventFinReproduccionCD", 1.45, token)  
  end
end
function VoiceCoolDown:PlaySoundFile(token, jugador, accion, hechizoID)
--Reproduce el fichero indicado de la ruta indicada pero tiene en cuenta
--si el usuario quiere que sea por el canal maestro ó no.  
--Si ya hay 2 CD esperando a ser reproducidos no encola ninguno mas
--Introduce en hablando un identificador único de la reproducción de este CD
--uso como indentificador unico de est reproducción el tiempo trasncurrido desde que arranco el ordenador = GetTime()


--Cuando a wow le dices que reproduzca 2 o mas ficheros de sonido lo que hace
--es que los supuerpone -> que tengo que usar temporizadores para que cada
--uno empieze despues del siguiente
  local idTimer  --Temporizador para empezar a reproducir 2º sonido de la frase  
  local idTimer3 --Espera a que haya reproducido todo para permitir nuevas reproduciones
  
  local primertoken -- Primer toque de la lista
  local posicion
  
  if self.db.global.debugSonido then
    self:Print("|cffffff00-------------------")
    self:Print("|cffffff00PlaySoundFile "..tostring(hechizoID))
  end
  
  --recupera la prioridad del hechizo pasado por parametro
  --Si el sonido es un casteo -> Esta en posicion 3, si es
  --disponible -> posicion 5
  prioridad = nil
  local i = self:IsMonitorizedSpell(tonumber(hechizoID))
  if self.db.global.debugSonido then
    self:Print("|cffffff00Posicion del hechizo: "..i)
  end
  if i > 0 then
    if accion == "disponible" then
        prioridad = self.db.profile.hechizosMonitorizados[i][5]
    else
        prioridad = self.db.profile.hechizosMonitorizados[i][3]
    end
  end
  if self.db.global.debugSonido then self:Print("Prioridad calculada: "..tostring(prioridad)) end
  if prioridad == nil then error(L["ERROR1"]) end 
  
  --Coloca el iten en la posicion adecuada, lo desecha o lo deja como estaba y obtiene en que caso 
  --estamos y la posicion en la cola del item
  resultadoencolar, posicion = self:QueueSound(token, jugador, accion, hechizoID, prioridad)
  
  if self.db.global.debugSonido then self:Print("ENTRANDO - numero de tokens en la lista:"..tostring(#self.Hablando)) end
  
  if self.db.global.debugSonido then 
    self:Print(tostring(jugador).." "..tostring(accion).." "..tostring(hechizoID).." "..tostring(token).." "..tostring(prioridad))
  end 
 
  -- Ni hay sitio para meterla ni tiene sufiente prioridad para quitar a otra de la cola y ponerse el 
  if resultadoencolar == 0 then 
    if self.db.global.debugSonido then self:Print("Me las piro vampiro") end
    return 
  end
  
  if resultadoencolar == 1 then 
    if self.db.global.debugSonido then self:Print("Nuevo sonido") end
  end
  
  --En el resto de los casos la función QueueSound ya ha ordenado 
  --lista y solo tendremos que seguir si es el primero de la lista
  token = self.Hablando[posicion][1] -- Recupera el token del elemento insertado
  primertoken = self.Hablando[1][1]
  if primertoken ~= token then -- No soy el primero -> Encolo
    if self.db.global.debugSonido then self:Print("No soy el primero en la lista -> Encolo") end
    self.Hablando[posicion][6] = self:ScheduleTimer("EventRetryPlay", 1.50, token)
    
    return
  end
  
  self.Hablando[posicion][6] = 0 -- Con este valor me garantizo que no me mueven de la primera posicion de la cola 
  self.Hablando[posicion][5] = prioridad
  if self.db.global.debugSonido then
    self:Print("Tokens en la lista")
    for i,defecto in ipairs(self.Hablando) do
      self:Print(i.." "..tostring(defecto[2]).." "..tostring(defecto[3]).." "..tostring(defecto[4]).." "..tostring(defecto[1]).." "..tostring(defecto[5]).." "..tostring(defecto[6]))
    end
  end
  if jugador == nil then
    if self.db.global.Maestro then
      PlaySoundFile(self.db.global.RutaVoces..accion..".mp3","Master")
    else
      PlaySoundFile(self.db.global.RutaVoces..accion..".mp3")
    end
    idTimer = self:ScheduleTimer("EventPlaySound", 0.45, hechizoID)
    idTimer3 = self:ScheduleTimer("EventFinReproduccionCD", 1.45, token)
  else
    if self.db.global.Maestro then
      PlaySoundFile(self.db.global.RutaVoces..jugador..".mp3","Master")
    else
      PlaySoundFile(self.db.global.RutaVoces..jugador..".mp3")
    end
    idTimer = self:ScheduleTimer("EventPlaySound", 0.45, hechizoID)
    --Transcurrido este tiempo sabe que ya ha terminado esta reproducción por eso hay timer con un evento 
    --que borra el token de la lista que hay en reproducción. El tiempo es la suma de lo que tarda en decir
    --Jugador+Acción+Hehcizo = 0.45 + 1 = 1.45
    idTimer3 = self:ScheduleTimer("EventFinReproduccionCD", 1.45, token)  
  end
  
end